#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xjf rrshd-1.2.tar.bz2
    cd rrshd-1.2
    ed -s Makefile >/dev/null <<EOF
/^CFLAGS = -O2/
s/-O2/$CFLAGS/
w
q
EOF
    make
    strip -R .note -R .comment in.rrshd
    mkdir -p ../rrshd/sbin
    cp in.rrshd ../rrshd/sbin/
    cd ..
    rm -rf rrshd-1.2
}

chmod 0600 rrshd/etc/rrsh.allow

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
